#pragma once
#include "TreeOptionsCtrlEx.h"

class CPPgTweaks : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgTweaks)

public:
	CPPgTweaks();
	virtual ~CPPgTweaks();

// Dialog Data
	enum { IDD = IDD_PPG_TWEAKS };

	void Localize(void);

protected:
	UINT m_iFileBufferSize;
	UINT m_iQueueSize;
	int m_iMaxConnPerFive;
	int m_iMaxHalfOpen;
	int m_iAutoTakeEd2kLinks;
	int m_iVerbose;
	int m_iDebugSourceExchange;
	int m_iLogBannedClients;
	int m_iLogRatingDescReceived;
	int m_iLogSecureIdent;
	int m_iLogFilteredIPs;
	int m_iLogFileSaving;
    int m_iLogA4AF; // ZZ:DownloadManager
	int m_iLogUlDlEvents;
// WebCache: ////////////////////////////////////////////////////////////////////////////////////
	int m_iLogWebCacheEvents;//JP log webcache events
	int m_iLogICHEvents;//JP log ICH events
/* new upnp disabled
	int		m_iLogUPnP;
*/
	//int m_iCreditSystem;
	int m_iLog2Disk;
	int m_iDebug2Disk;
	int m_iCommitFiles;
	int m_iFilterLANIPs;
	int m_iExtControls;
	UINT m_uServerKeepAliveTimeout;
	int m_iSparsePartFiles;
	int m_iCheckDiskspace;	// SLUGFILLER: checkDiskspace
	float m_fMinFreeDiskSpaceMB;
	CString m_sYourHostname;	// itsonlyme: hostnameSource
	int m_iFirewallStartup;
	int m_iLogLevel;
	int m_iDisablePeerCache;

	int m_bEnableACC; //Obelix
	//int m_iPawcioCredits; //Pawcio: Credits
	int m_iTimeUp; // Pawcio: BC
	int m_iTimeDown; // Pawcio: BC Download
	//Pawcio: BC removed
    int m_iA4AFSaveCpu; // ZZ:DownloadManager
	int m_iExtractMetaData;

        // Morph: PowerShare
	int m_iPowershareMode; //MORPH - Added by [ionix], Avoid misusing of powersharing
	int m_iHideOS;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	int m_iSelectiveShare;  //MORPH - Added by [ionix], SLUGFILLER: hideOS
	int m_iShareOnlyTheNeed; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	int m_iPowerShareLimit; //MORPH - Added by [ionix], POWERSHARE Limit
        // <--- Morph: PowerShare
	int m_iHighProcess; //MORPH - Added by IceCream, high process priority

	CSliderCtrl m_ctlFileBuffSize;
	CSliderCtrl m_ctlQueueSize;
    CTreeOptionsCtrlEx m_ctrlTreeOptions;
	bool m_bInitializedTreeOpts;
	HTREEITEM m_htiMaxCon5Sec;
	HTREEITEM m_htiMaxHalfOpen;
	HTREEITEM m_htiAutoTakeEd2kLinks;
	HTREEITEM m_htiVerboseGroup;
	HTREEITEM m_htiVerbose;
	HTREEITEM m_htiDebugSourceExchange;
	HTREEITEM m_htiLogBannedClients;
	HTREEITEM m_htiLogRatingDescReceived;
	HTREEITEM m_htiLogSecureIdent;
	HTREEITEM m_htiLogFilteredIPs;
	HTREEITEM m_htiLogFileSaving;
    HTREEITEM m_htiLogA4AF; // ZZ:DownloadManager
	HTREEITEM m_htiLogUlDlEvents;
// WebCache: ////////////////////////////////////////////////////////////////////////////////////
	HTREEITEM m_htiLogWebCacheEvents; //jp log webcache events
	HTREEITEM m_htiLogICHEvents; //JP log ICH events
/* new upnp disabled
	HTREEITEM	m_htiLogUPnP;
	// End -UPnPNAT Support-
*/
	//HTREEITEM m_htiCreditSystem;
	HTREEITEM m_htiLog2Disk;
	HTREEITEM m_htiDebug2Disk;
	HTREEITEM m_htiCommit;
	HTREEITEM m_htiCommitNever;
	HTREEITEM m_htiCommitOnShutdown;
	HTREEITEM m_htiCommitAlways;
	HTREEITEM m_htiFilterLANIPs;
	HTREEITEM m_htiExtControls;
	HTREEITEM m_htiServerKeepAliveTimeout;
	HTREEITEM m_htiSparsePartFiles;
	HTREEITEM m_htiCheckDiskspace;	// SLUGFILLER: checkDiskspace
	HTREEITEM m_htiMinFreeDiskSpace;
	HTREEITEM m_htiYourHostname;	// itsonlyme: hostnameSource
	// Removed by [ionix] [MoNKi: -Improved ICS-Firewall support-]
	/* Moved to PPgEmulespana
	HTREEITEM m_htiFirewallStartup;
	*/
	// End emulEspaa
	HTREEITEM m_htiLogLevel;
	HTREEITEM m_htiDisablePeerCache;

	HTREEITEM m_htiEnableACC; //Obelix
	//HTREEITEM m_htiPawcioCredits; //Pawcio: Credits
	HTREEITEM m_htiTimeUp; //Pawcio: BC
	HTREEITEM m_htiTimeDown; //Pawcio: BC Download
	//Pawcio: BC removed

	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo
	HTREEITEM m_htiBufferTimeLimit; // Buffer Time Limit - //
	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo

	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo
	int m_iBufferTimeLimit; // Buffer Time Limit - //
	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo

	// ZZ:DownloadManager -->
    HTREEITEM m_htiA4AFSaveCpu;
	// ZZ:DownloadManager <--
	HTREEITEM m_htiExtractMetaData;
	HTREEITEM m_htiExtractMetaDataNever;
	HTREEITEM m_htiExtractMetaDataID3Lib;
	HTREEITEM m_htiExtractMetaDataMediaDet;

        // Morph: PowerShare
	HTREEITEM m_htiUM;
	HTREEITEM m_htiSFM;
	HTREEITEM m_htiPowershareMode;
	HTREEITEM m_htiPowershareDisabled;
	HTREEITEM m_htiPowershareActivated;
	HTREEITEM m_htiPowershareAuto;
	HTREEITEM m_htiPowershareLimited;
	HTREEITEM m_htiHideOS;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	HTREEITEM m_htiSelectiveShare; //MORPH - Added by [ionix], SLUGFILLER: hideOS
	HTREEITEM m_htiShareOnlyTheNeed; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	HTREEITEM m_htiPowerShareLimit; //MORPH - Added by [ionix], POWERSHARE Limit
        // <--- Morph: PowerSHare
	HTREEITEM m_htiHighProcess; //MORPH - Added by IceCream, high process priority

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	virtual BOOL OnKillActive();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDestroy();
	afx_msg LRESULT OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam);
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
};
